<?php 

/**
 * Classe plxCaroufredsel
 *
 * @version 2.0.0
 * @date	22/12/2018 + @author	Thomas Ingles
 * @version 1 @date	01/12/2011 + @author	Cyril MAGUIRE
 **/

class plxcaroufredsel extends plxPlugin {

	/**
	 * Constructeur de la classe
	 *
	 * @return	void
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire) 
		parent::__construct($default_lang);
		# Ajoute des hooks
		$this->addHook('plxMotorParseArticle', 'plxMotorParseArticle');
		$this->addHook('plxMotorGetStatiques', 'plxMotorGetStatiques');
		if(defined('PLX_ADMIN')){//backend
			$this->addHook('AdminPrepend', 'AdminPrepend');
			$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
			$this->addHook('AdminMediasFoot', 'AdminMediasFoot');
			$this->addHook('AdminMediasPrepend', 'AdminMediasPrepend');
			# Pour les articles
			$this->addHook('AdminArticleContent', 'AdminArticleContent');
			$this->addHook('AdminArticleInitData', 'AdminArticleInitData');
			$this->addHook('AdminArticlePrepend', 'AdminArticlePostData');
			$this->addHook('AdminArticleParseData', 'AdminArticleParseData');
			$this->addHook('plxAdminEditArticle', 'plxAdminEditArticle');
			$this->addHook('AdminTopBottom', 'AdminTopBottom');
			$this->addHook('AdminFootEndBody', 'AdminFootEndBody');
			$this->addHook('plxAdminEditArticleXml', 'plxAdminEditArticleXml');
			#Pour les pages statiques
			$this->addHook('AdminStaticsPrepend', 'AdminStaticsPrepend');
			$this->addHook('AdminStaticPrepend', 'AdminStaticPrepend');
			$this->addHook('AdminStatic', 'AdminStatic');
			$this->addHook('AdminStaticTop', 'AdminStaticTop');
			$this->addHook('plxAdminEditStatiquesXml', 'plxAdminEditStatiquesXml');
			$this->addHook('plxAdminEditStatique', 'plxAdminEditStatique');
			$this->addHook('plxAdminEditStatiquesUpdate', 'plxAdminEditStatiquesUpdate');
		}else{//Frontend
			$this->launchJs = '';
			$this->addHook('Index', 'Index');
			$this->addHook('ThemeEndBody', 'ThemeEndBody');
			$this->addHook('ThemeEndHead', 'caroufredselCss');
			$this->addHook('caroufredselJs', 'caroufredselJs');
			$this->addHook('caroufredselMobileJs', 'caroufredselMobileJs');
			$this->addHook('caroufredselFooter', 'caroufredselFooter');
			$this->addHook('caroufredselFooterMobile', 'caroufredselFooterMobile');
			# Pour les articles
			$this->addHook('caroufredselContent', 'caroufredselContent');
			$this->addHook('caroufredselArticle', 'caroufredselArticle');
			$this->addHook('caroufredselHome', 'caroufredselHome');
			#Pour les pages statiques
			$this->addHook('caroufredselStaticContent', 'caroufredselStaticContent');
			$this->addHook('caroufredselStatic', 'caroufredselStatic');
		}
	}

	/**
	 * Méthode pour le hook AdminPrepend $MEDIA_FOLDER = PLX_ROOT.'data/medias/';//data/images/ (OLD)
	 * @return	void
	 * @author	Thomas Ingles 
	 **/
 	public function AdminPrepend() {
		echo '<?php '; ?>
		if(isset($plxAdmin->aConf['medias'])){// plx.5.4+
			$plxAdmin->aConf['caroufredselmedias'] = $plxAdmin->aConf['medias'];
		}else{
			$plxAdmin->aConf['caroufredselmedias'] = $plxAdmin->aConf['images'];
		}
?><?php 
	}

	/**
	 * Méthode pour le hook Index $MEDIA_FOLDER = PLX_ROOT.'data/medias/';//data/images/ (OLD)
	 * @return	void
	 * @author	Thomas Ingles 
	 **/
 	public function Index() {
		echo '<?php '; ?>
		if(isset($plxMotor->aConf['medias'])){// plx.5.4+
			$plxMotor->aConf['caroufredselmedias'] = $plxMotor->aConf['medias'];
		}else{
			$plxMotor->aConf['caroufredselmedias'] = $plxMotor->aConf['images'];
		}
?><?php 
	}

/**************************
*
*	LES ARTICLES
*
**************************/

	/**
	 * Méthode pour le hook plxMotorParseArticle
	 *
	 * Récupère la valeur de mavariable enregistrée précédemment dans le fichier xml
	 * et l'affecte à l'index mavariable du tableau $art. Permet d'afficher la valeur de mavariable dans la vue
	 * via $plxShow->plxMotor->plxRecord_arts->f('mavariable')
	 *
	 * @return	void
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorParseArticle() {
echo '<?php '; ?>
		$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfartId cfprevnext');
		foreach($cfred AS $sfparm){
			$$sfparm = plxUtils::getValue($iTags[$sfparm][0]);
			$art[$sfparm] = plxUtils::getValue($values[$$sfparm]['value']); 
		}
?><?php 
	}

	/**
	 * Méthode pour le hook AdminArticleContent
	 * Affiche le formulaire dans la vue admin/article.php permettant la création / l'édition d'un article
	 **/
	public function AdminArticleContent() {
		$this->AdminForm('article');
	}

	/**
	 * Méthode pour le hook AdminArticlePrepend
	 *
	 * @author	Thomas Ingles
	 */
	public function AdminArticlePrepend() {
echo '<?php '; ?>
//apres ds admin/article.php script
# Formulaire validé
if(!empty($_POST)) { # Création, mise à jour, suppression ou aperçu
	# Si profil PROFIL_WRITER on vérifie l'id du rédacteur connecté et celui de l'article
	if($_SESSION['profil']==PROFIL_WRITER AND isset($_POST['author']) AND $_SESSION['user']!=$_POST['author']) $_POST['cfauthor']=$_SESSION['user'];
}
?><?php
	}

	/**
	 * Méthode pour le hook AdminArticleInitData
	 * Permet de donner des valeurs par défaut lorsqu'un article est créé
	 * @author	Cyril MAGUIRE
	 */
	public function AdminArticleInitData() {
echo '<?php '; ?>
			$cfsel = '';
			$width = 600;
			$height = '';
			$direction = 'left';
			$cfprevnext = '';
?><?php
	}

	/**
	 * Méthode pour le hook AdminArticlePostData (oups) AdminArticlePrepend
	 * Permet d'alimenter des variables lorsque le formulaire de création d'un article est posté
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 */
	public function AdminArticlePostData(){
echo '<?php '; ?>
		# Formulaire validé
		if(!empty($_POST)) { # Création, mise à jour, suppression ou aperçu
			$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');//
			foreach($cfred AS $sfparm) ${$sfparm} = @$_POST[$sfparm];
		}
?><?php
	}

	/**
	 * Méthode pour le hook AdminArticleParseData
	 * Affectation de la valeur de $result['mavariable'] à $mavariable précédemment récupérée par plxAdmin via 
	 * $art de plxMotor (voir plxShowConstruct plus haut)
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminArticleParseData()	{
echo '<?php '; ?>
		$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');//
		foreach($cfred AS $sfparm) ${$sfparm} = @$result[$sfparm];
?><?php
	}

	/**
	 * Méthode pour le hook plxAdminEditArticle
	 * Crée l'index mavariable dans le tableau $content nécessaire à la classe plxAdmin pour créer le fichier xml (data)
	 * Crée, s'il n'existe pas, le dossier dans lequel seront stockées les images du diaporama
	 * @return void
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditArticle() {
echo '<?php '; ?>
			//si l'article n'a pas de diaporama
			if (!isset($content['cfsel'])) {//$content['cfsel'] != 'on'
				$cfred = explode(' ','width height direction infinite auto cfauthor cfprevnext');// cfsel
				foreach($cfred AS $sfparm) $content[$sfparm] = '';//On efface
			} else {
				$content['cfsel'] = 'on';
				$MEDIA_FOLDER = PLX_ROOT.$this->aConf['caroufredselmedias'];// data/medias/ data/images/ (OLD)
				$u = '';
				$newdir = $MEDIA_FOLDER.'diaporamas/article-'.$id;
				//s'il y a un dossier par utilisateur écrivains
				if($this->aConf['userfolders']){
					if($_SESSION['profil'] == PROFIL_WRITER) {//$_SESSION['profil'] == 0 (OLD)
						//$u = $content['author'].'/';//est dèja sa racine "media/uid/", inutile de lui mentir ;)
						$content['cfauthor'] = $_SESSION['user'];// ;)
						$newdir = $MEDIA_FOLDER.$_SESSION['user'].'/diaporamas/article-'.$id;
					}
					elseif($_SESSION['profil'] < PROFIL_WRITER AND $this->aUsers[$content['author']]['profil'] == PROFIL_WRITER) {//
						$content['cfauthor'] = $content['author'];// ;)
						$u = $content['author'].'/';//racine de ses "media/uid/" ;)
						$newdir = $MEDIA_FOLDER.$content['author'].'/diaporamas/article-'.$id;
					}
				}
				if(!is_dir($newdir)) { # Si le dossier n'existe pas on le crée
					if(!@mkdir($newdir,0755,true)){
						return plxMsg::Error(L_PLXMEDIAS_NEW_FOLDER_ERR);
					}
				}
				$_SESSION['infoCfsel'] = '<div id="Cfsel" class="notification success"><p style="text-align:center;">Les images du diaporama sont à mettre dans le dossier&nbsp;:<br/><a title="'.L_VIEW.' - '.L_MEDIAS_TITLE.'" href="javascript:void(0)" onClick="cfsel_medias(this);">'.$u.'diaporamas/article-'.$id.'</a></p></div>';
			}
?><?php

	}

	/**
	 * Méthode pour le hook plxAdminEditArticleXml
	 * Enregistre la valeur de $mavariable dans le fichier xml, entre les tags <mavariable></mavariable>
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditArticleXml() {
echo '<?php '; ?>
		$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
		foreach($cfred AS $sfparm)// ${$sfparm} = $plxAdmin->aStats[$id][$sfparm];//init basic
			$xml .= '	<'.$sfparm.'><![CDATA['.plxUtils::cdataCheck(@$content[$sfparm]).']]></'.$sfparm.'>'.PHP_EOL;
		$xml .= '	<cfartId><![CDATA['.plxUtils::cdataCheck($id).']]></cfartId>'.PHP_EOL;
?><?php 
	}

	/**
	 * Méthode permettant l'affichage du style css de la notif (NOSCRIPT) + init $_SESSION['infoCfsel']
	 * @return stdio
	 * @author	Thomas Ingles
	 */
	public function AdminTopEndHead() {?>
		<style style="display:none">#Cfsel .notification.success{top:3rem;}</style>
<?php echo '<?php '; ?>
		if(!isset($_SESSION['infoCfsel'])) $_SESSION['infoCfsel'] = '';
?><?php
	}

	/**
	 * Méthode permettant l'affichage de la notif utilisateurs
	 * @return stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 */
	public function AdminTopBottom() {
echo '<?php '; ?>
		echo $_SESSION['infoCfsel'];
?><?php
	}

	/**
	 * Méthode permettant De créer/modifié les variables de session médias lors du (premier) post (lien art / stat)
	 * @return void
	 * @author	Thomas Ingles
	 */
	public function AdminMediasPrepend() {
echo '<?php '; ?>
		if(!empty($_POST['folder']) AND isset($_POST['btn_cfsel_ok'])) {//caroufredsel
			if(!isset($_SESSION['medias'])){//1er post (visite)
				$_SESSION['medias'] = $plxAdmin->aConf['caroufredselmedias'];
			}
			$_SESSION['folder'] = ($_POST['folder']=='.'?'':$_POST['folder']);
		}
?><?php
	}

	/**
	 * Méthode permettant l'affichage du lien de la page ou article dans le gestionnaire de média
	 * @return stdio
	 * @author	Thomas Ingles
	 */
	public function AdminMediasFoot() {
		$curFolder = '/'.plxUtils::strCheck(basename($_SESSION['medias']).'/'.$_SESSION['folder']);
		$curFolders = explode('/', $curFolder);

		if($curFolders) {
			$path='';
			$diap=0;
			$mode='';
			$akjs=0;
			foreach($curFolders as $id => $folder) {
				if(!empty($folder) AND $id>1) {
					//$path .= $folder.'/';
					if($diap) {
						$mode=explode('-',$folder);
						if(in_array($mode[0],array('article','static'))){
							if(isset($mode[1]) AND is_numeric($mode[1])){
								$link = ($mode[0] != 'static') ? $mode[0].'.php?a=': 'statique.php?p=';/* article.php?a=0002 * statique.php?p=009 */
								echo '<p id="'.__CLASS__.'Link"><sup><sub> <a title="(Diaporama '.__CLASS__.')" href="'.$link.$mode[1].'">'.($mode[0]!='static'?L_ARTICLE_EDIT_TITLE:L_STATICS_SRC_TITLE).'</a></sub></sup></p>';
								$akjs=!0;//Active js
							}
						}
					}
					if($folder == 'diaporamas') {
						$diap=$id;
					}
				}
			}
		}
		if($akjs):
?>
	<script type="text/javascript">
			var elemLink = window.document.getElementById('<?php echo __CLASS__ ?>Link');//lien édit
			var pageTitle = window.document.getElementsByTagName('H2');//Titres
			var pageTitle = pageTitle[0];//Titre page (media manager)
			pageTitle.appendChild(elemLink.firstChild);//Déplace le lien a dans le Titre
	</script>
<?php
endif;//$akjs
	}

	/**
	 * Méthode permettant l'affichage pour les pages : path_url core/admin/ article.php?a=#### et statique.php?p=###
	 * des fonctions 
	 * Formulaire pour accéder au bon dossier dans les médias
	 * Des fonctions Javascript 
	 * pour voir le dossier dans la gestion des média (poste le formulaire) les notifications utilisateurs
	 * pour les notifications utilisateurs
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 */
	public function AdminFootEndBody() {
echo '<?php '; ?>
		if(FALSE !== strpos($plxAdmin->path_url,'article.php?') OR FALSE !== strpos($plxAdmin->path_url,'statique.php?')):
?>
	<form action="medias.php" method="post" id="cfsel_form_medias">
		<?php echo plxToken::getTokenPostMethod(); ?>
		<input type="hidden" id="folder" name="folder" value="" />
		<input type="submit" id="btn_cfsel_ok" name="btn_cfsel_ok" value="Ok" style="display:none">
	</form>
	<script type="text/javascript">
		function cfsel_medias(e){
			window.document.getElementById('folder').value = e.innerHTML+'/';//diaporamas folder (art stat)
			window.document.getElementById('btn_cfsel_ok').click();//go to media manager
		}
	</script>
<?php
echo '<?php '; ?>
		endif;
		if('' != $_SESSION['infoCfsel'])://Si notif
			$_SESSION['infoCfsel'] = '';
?>
	<script type="text/javascript">
		function setMsgCfsel() {
			var cfsel = document.getElementById('Cfsel');
			if(cfsel) {
				var objDiv = cfsel;//document.getElementById('Cfsel');
				if (typeof window.innerWidth != 'undefined') {
					wndWidth = window.innerWidth;
				}
				else if (typeof document.documentElement != 'undefined' && typeof document.documentElement.clientWidth !='undefined' && document.documentElement.clientWidth != 0) {
					wndWidth = document.documentElement.clientWidth;
				}
				else {
					wndWidth = document.getElementsByTagName('body')[0].clientWidth;
				}
				xpos = Math.round(((wndWidth-objDiv.offsetWidth)/2));
				objDiv.style.left=xpos+'px';
				objDiv.style.top='3rem';
				fadeOut('Cfsel');
				document.getElementById('CfselMsg').innerHTML = objDiv.firstChild.innerHTML;//duplicate info
			}
		}
		setMsgCfsel();
	</script>
<?php
echo '<?php 		endif; ?>';
	}

	/**
	 * Méthode pour le hook caroufredselCss permettant d'afficher le fichier css
	 *
	 * @author Cyril MAGUIRE
	 */
	public function caroufredselCss() {?>
		<link rel="stylesheet" type="text/css" href="<?php echo PLX_PLUGINS.__CLASS__ ?>/css/style.css" />
<?php
	}

	/**
	 * Méthode permettant d'afficher le fichier caroufredsel.js et jquery
	 *
	 * @author Cyril MAGUIRE
	 */
	public function ThemeEndBody() {?>
		<script type="text/javascript">
				/* <![CDATA[ */
				!window.jQuery && document.write('<script type="text/javascript" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/js/jquery-3.2.1.min.js"><\/script>');
				/* !]]> */
			</script>
		<script type="text/javascript" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/js/jquery.carouFredSel-6.2.1-packed.js"></script>
		<script type="text/javascript" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/js/jquery.easing-1.4.1.min.js"></script>
<?php
		echo $this->launchJs;
	}

	/**
	 * Méthode pour le hook caroufredselContent permettant d'afficher le diaporama dans l'article
	 */
	public function caroufredselContent($params) {
		$this->caroufredsel($params, 'article');
	}

/**************************
*
*	LES PAGES STATIQUES
*
**************************/

	/**
	 * Méthode pour le hook AdminStatic
	 * Affiche le formulaire dans la vue admin/statique.php permettant la création / l'édition de la page
	 **/
	public function AdminStatic() {
		$this->AdminForm('static');
	}

	/**
	 * Méthode qui ajoute les paramètres du diaporama dans la chaine xml à sauvegarder dans statiques.xml
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditStatiquesXml() {
echo '<?php '; ?>
			$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
			if(!isset($static['cfsel'])){//statiques (create stat) ou 1st time  : Fix $static['cfsel'] undefined
				foreach($cfred AS $sfparm)
					if(!isset($static[$sfparm]))
						$static[$sfparm] = '';
			}
			foreach($cfred AS $sfparm)
				$xml .= '<'.$sfparm.'><![CDATA['.plxUtils::cdataCheck($static[$sfparm]).']]></'.$sfparm.'>'; 
			$cfartId = isset($static_id)?$static_id:$id;//$id is (old old plux 2012)
			$xml .= '<cfartId><![CDATA['.plxUtils::cdataCheck($cfartId).']]></cfartId>';
?><?php
	}

	/**
	 * Méthode qui récupère les paramètres du diaporama saisis lors de l'édition de la page statique
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditStatique() {
echo '<?php '; ?>
		//si la page n'a pas de diaporama
		if (!isset($content['cfsel'])) {// OR $content['cfsel'] != 'on'
			$cfred = explode(' ','cfsel width height direction infinite auto cfprevnext');// cfauthor
			foreach($cfred AS $sfparm){
				$content[$sfparm] = '';
				$this->aStats[$content['id']][$sfparm] = $content[$sfparm];
			}
		} else {
			$cfred = explode(' ','cfsel width height direction infinite auto cfprevnext');// cfauthor
			foreach($cfred AS $sfparm){
				$this->aStats[$content['id']][$sfparm] = @$content[$sfparm];
			}
			$this->aStats[$content['id']]['cfauthor'] = $_SESSION['user'];
			$MEDIA_FOLDER = $this->aConf['caroufredselmedias'];// data/medias/ data/images/ (OLD)
			$newdir = PLX_ROOT.$MEDIA_FOLDER.'diaporamas/static-'.$content['id'];
			if(!is_dir($newdir)){ # Si le dossier n'existe pas on le crée
				if(!@mkdir($newdir,0755,true)){
					return plxMsg::Error(L_PLXMEDIAS_NEW_FOLDER_ERR);
				}
			}
			$_SESSION['infoCfsel'] = '<div id="Cfsel" class="notification success"><p style="text-align:center;">Les images du diaporama sont à mettre dans le dossier&nbsp;:<br/><a title="'.L_VIEW.' - '.L_MEDIAS_TITLE.'" href="javascript:void(0)" onClick="cfsel_medias(this);">diaporamas/static-'.$content['id'].'</a></p></div>';
		}
?><?php
	}

	/**
	 * Méthode qui récupère les paramètres du diaporama saisis lors de l'édition de la page statique pour mettre à jour les données enregistrées
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditStatiquesUpdate() {
echo '<?php '; ?>
		$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
		if(isset($content['staticNum'])){
			foreach($content['staticNum'] AS $id){
				//si la page n'a pas de diaporama
				if (!empty($this->aStats[$id]['name']) AND !isset($this->aStats[$id]['cfsel'])) {//first time
					foreach($cfred AS $sfparm) $content[$id.'_'.$sfparm] = '';
				}
			}
		} else
			foreach($cfred AS $sfparm) $this->aStats[$static_id][$sfparm] = $content[$static_id.'_'.$sfparm];
?><?php
	}

	/**
	 * Méthode qui récupère les paramètres du diaporama stockés dans le fichier xml statiques.xml
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorGetStatiques() {
echo '<?php '; ?>
		$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
		foreach($cfred AS $sfparm){
			${$sfparm} = plxUtils::getValue($iTags[$sfparm][$i]);
			$this->aStats[$number][$sfparm]=plxUtils::getValue($values[${$sfparm}]['value']); 
		}
?><?php
	}

	/**
	 * Méthode qui récupère les paramètres du diaporama stockés dans le fichier xml statiques.xml
	 * et qui les passe au formulaire de paramètrage du diaporama dans le fichier statique.php
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminStaticTop() {
echo '<?php '; ?>
		$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
		foreach($cfred AS $sfparm) ${$sfparm} = $plxAdmin->aStats[$id][$sfparm];//init basic
?><?php
	}

	/**
	 * Méthode qui initie les varaiables de la nouvelle Static
	 *
	 * @author	Thomas Ingles
	 **/
	public function AdminStaticPrepend() {//2.0.0
echo '<?php '; ?>
			if(!empty($_GET['p'])) { # On affiche le contenu de la page
				$id = plxUtils::strCheck(plxUtils::nullbyteRemove($_GET['p']));
				if(!isset($plxAdmin->aStats[ $id ])) {
					plxMsg::Error(L_STATIC_UNKNOWN_PAGE);
					header('Location: statiques.php');
					exit;
				}
				if(empty($plxAdmin->aStats[$id]['cfsel'])){
					$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
					foreach($cfred AS $sfparm) $plxAdmin->aStats[$id][$sfparm] = '';//init (new)
				}
			}
?><?php
	}

	/**
	 * Méthode qui initie les varaiables Statics
	 * @author	Thomas Ingles
	 **/
	public function AdminStaticsPrepend() {//2.0.0
echo '<?php '; ?>
			if(empty($_POST) AND !empty($plxAdmin->aStats)){
				$cfred = explode(' ','cfsel width height direction infinite auto cfauthor cfprevnext');
				foreach($plxAdmin->aStats AS $id => $stat){
					if(!isset($plxAdmin->aStats[$id]['cfsel'])){
						foreach($cfred AS $sfparm) $plxAdmin->aStats[$id][$sfparm] = '';//init (new)
					}
				}
			}
?><?php
	}

	/**
	 * Méthode pour le hook caroufredselContent permettant d'afficher le diaporama dans une page statique
	 */
	public function caroufredselStaticContent($params) {
		$this->caroufredsel($params, 'static');
	}

/**************************
*
*	FONCTIONS COMMUNE
*
**************************/

	/**
	 * Méthode Commune pour les hooks AdminStatic et AdminArticleContent qui affiche le formulaire
	 * de la vue admin/article.php permettant la création / l'édition d'un article
	 * de la vue admin/statique.php permettant la création / l'édition de la page
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminForm($mode = 'static') {//2.0.0
echo '<?php '; ?>
		$selected = $up = $down = $right = $ifalse = $afalse = '';
		$left = $itrue = $atrue = ' selected="selected"';
		$display = 'none';
		if($cfsel){//$cfsel == 'on'
			$selected = ' checked="checked"';
			$display = 'block';
			$up = $down = $right = $left = $itrue = $ifalse = $atrue = $afalse = '';
			$$direction = ' selected="selected"';
			$vname = 'i'.$infinite;
			$$vname = ' selected="selected"';
			$vname = 'a'.$auto;
			$$vname = ' selected="selected"';
		}
		$cfprevnextchecked = ($cfprevnext == 'on') ? ' checked="checked"' : '';

		switch('<?php echo $mode ?>'){
			case 'article':
				$u = '';
				//s'il y a un dossier par utilisateur écrivains
				if($cfsel AND $plxAdmin->aConf['userfolders']){
					$aFileInfos = explode('.',$plxAdmin->plxGlob_arts->aFiles[$artId]);
					$pos = count($aFileInfos) - 4;//used id
					$userFile = $aFileInfos[$pos];
					if ($_SESSION['user'] != $userFile AND $plxAdmin->aUsers[$userFile]['profil'] == PROFIL_WRITER) {//Article d'écrivains (Rédacteur)
						$u = $userFile.'/';//on préserve son dossier
					}
				}
				$cfFolder = $u.'diaporamas/article-'.$artId;
				$cfMode = 'Cet article contient-il';
				break;
			default://static
				$cfid = isset($_GET['p'])?$_GET['p']:$id;// Fix : $id is last lang id of plxMyMultilingue flags (use $_GET['p'])
				$cfFolder = 'diaporamas/static-'.$cfid;
				$cfMode = 'Cette page contient-elle';
		}

		echo '
			<label for="cfsel">'.$cfMode.' un diaporama&nbsp;?&nbsp;('.($cfsel?L_YES:L_NO).')&nbsp;<input type="checkbox" id="cfsel" name="cfsel"'.$selected.' onclick="$(\'#CfselOptions\').toggle(\'slide\');"/></label>
			<div id="CfselOptions">
				<span id="CfselMsg" style="color:tomato">'.($cfsel?'Les images du diaporama sont à mettre dans le dossier&nbsp;:<br/><a title="'.L_VIEW.' - '.L_MEDIAS_TITLE.'" href="javascript:void(0)" onClick="cfsel_medias(this);">'.$cfFolder.'</a>':'').'</span>
				<p><label for="width">Largeur du diaporama (nombre, null, variable ou auto)<br class="med-hide"/>
					<em>Dans le doute, laissez vide</em> :</label></p>
					<input type="text" name="width" value="'.$width.'" id="width" />
					<br class="hide" />
				<p><label for="height">Hauteur du diaporama (nombre ou auto)<br class="med-hide"/>
					<em>Dans le doute, laissez vide</em> :</label></p>
					<input type="text" name="height" value="'.$height.'" id="height" />
					<br class="hide" />
				<p><label for="direction">Direction du diaporama :</label></p>
				<select name="direction" id="direction">
					<option value="up"'.$up.'>haut</option>
					<option value="down"'.$down.'>bas</option>
					<option value="left"'.$left.'>gauche</option>
					<option value="right"'.$right.'>droite</option>
				</select>
					<br class="hide" />
				<p><label for="infinite">Diaporama en boucle :</label></p>
				<select name="infinite" id="infinite">
					<option value="true"'.$itrue.'>'.L_YES.'</option>
					<option value="false"'.$ifalse.'>'.L_NO.'</option>
				</select>
					<br class="hide" />
				<p><label for="auto">Diaporama automatique :</label></p>
				<select name="auto" id="auto">
					<option value="true"'.$atrue.'>'.L_YES.'</option>
					<option value="false"'.$afalse.'>'.L_NO.'</option>
				</select>
					<br class="hide" />
				<label for="cfprevnext">Affichage des liens "prev" et "next"&nbsp;?&nbsp;('.($cfprevnext?L_YES:L_NO).')&nbsp;:<input type="checkbox" id="cfprevnext" name="cfprevnext"'.$cfprevnextchecked.'/></label>
					<br class="hide" />
			</div>
			<script type="text/javascript">
				/* <![CDATA[ */
				!window.jQuery && document.write(\'<script type="text/javascript" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/js/jquery-3.2.1.min.js"><\/script>\');
				/* !]]> */
			</script>
			<script type="text/javascript">
				jQuery(function($) {
					$(\'#CfselOptions\').css({\'display\':\''.$display.'\'});
				});
			</script>'.PHP_EOL;
?><?php
	}

	/**
	 * Méthode Commune pour les hooks caroufredsel(Static)Content permettant d'afficher le diaporama dans l'article / page statique
	 * @return	stdio
	 * @author Thomas Ingles
	 */
	public function caroufredsel($params, $mode = 'static') {
		switch($mode){
			case 'article':
				$u = '';
				//S'il y a un dossier par utilisateur rédacteur
				$plxMotor = plxMotor::getInstance();
				$MEDIA_FOLDER = $plxMotor->aConf['caroufredselmedias'];// data/medias/ data/images/ (OLD)
				if (!empty($params['userfolder']) AND $plxMotor->aUsers[$params['cfauthor']]['profil'] == PROFIL_WRITER) {//Article d'écrivains (Rédacteur)
					$u = $params['cfauthor'].'/';//on préserve son dossier
				}
				$folder = $MEDIA_FOLDER.$u.'diaporamas/article-'.$params['cfartId'].'/';
				$idcf = $params['cfauthor'].'-'.$params['cfartId'];
//				$sizecf = $params['cfauthor'].'-'.$params['cfartId'];//$params['cfauthor'].'-'.$params['cfartId'];
				$idzg = $params['cfartId'];
				break;
			default://static
				$MEDIA_FOLDER = $this->media_folder;// data/medias/ data/images/ (OLD)
				$folder = $MEDIA_FOLDER.'diaporamas/static-'.$params['id'].'/';
				$idcf = 'static-'.$params['id'];
//				$sizecf = $params['cfauthor'].'-'.$params['id'];//'static-'.$params['id'];
				$idzg = $params['id'];
		}
		if(!is_dir(PLX_ROOT.$folder)) return;
		$dir = opendir(PLX_ROOT.$folder);
		$lienDir = $folder;
		//Listing des images du dossier
		$listImgs = array();
		$listImg = $thumb = '';
		$larg = $haut = 0;
		while($file = readdir($dir)) {
			if($file != '..' && $file != '.' && strpos($file,'.tb.') === false && strpos($file,'.DS_Store') === false) {
				$listImgs[] = $file;
			}
		}
		if(empty($listImgs)) return;
		natsort($listImgs);
		foreach ($listImgs as $key => $file) {
			$type = mime_content_type($lienDir.$file);
			$type = explode('/',$type);
			$type = $type[0];
			//~ $ext = substr($file,(strpos($file,'.')+1));
			$ext = explode('.',$file); $ext = end($ext);
			if($type == 'image' and in_array(strtolower($ext), array('png', 'gif', 'jpg', 'jpeg'))){
				$thumb = $lienDir.str_replace('.'.$ext,'.tb.'.$ext,$file);
			}
			else{
				$thumb = PLX_PLUGINS.__CLASS__.'/img/free-file-icons/100px/_blank.png';//16 32 48 px
				if(file_exists(PLX_PLUGINS.__CLASS__.'/img/free-file-icons/100px/'.$ext.'.png'))
					$thumb = PLX_PLUGINS.__CLASS__.'/img/free-file-icons/100px/'.$ext.'.png';
			}
			$attr = getimagesize(PLX_ROOT.$thumb);
			if ($haut < ($attr[1] + 20)) {
				$haut = ($attr[1] + 20);
			}
			if ($larg < $attr[0]) {
				$larg = $attr[0];
			}
			$listImg .= '
					<a href="'.$lienDir.$file.'" class="zoombox zgallery'.$idzg.'">
						<img src="'.$thumb.'" '.$attr[3].' alt="'.$file.'" />
					</a>'.PHP_EOL;
		}//hcaerof
/*
		if (!in_array($params['height'],array('auto','variable','null'))) {
			$params['height'] = intval($params['height']);
		} else {
			$params['height'] = $params['height'];//'"auto"''"variable"'
		}
  if (empty($params['height']) || $params['height'] == 'null') {
			$params['height'] = $haut;
		}
		$haut = $params['height'];
*/
		if ($params['cfprevnext'] == 'on') {
			$prevnext = '
				<a class="prev" id="diaporama-'.$idcf.'-prev" href="#"><span>prev</span></a>
				<a class="next" id="diaporama-'.$idcf.'-next" href="#"><span>next</span></a>'.PHP_EOL;
		} else {
			$prevnext = '';
		}

		//Affichage des images
	 	echo '
			<div class="cfcaroussel '.$params['direction'].'">
				<div id="diaporama-'.$idcf.'" data-cflarg="'.$larg.'" data-cfhaut="'.$haut.'">'.$listImg.'
				</div>
				<div class="clearfix">&nbsp;</div>'.$prevnext.'
				<div class="cfpagination" id="diaporama-'.$idcf.'-pages"></div>
			</div>'.PHP_EOL;
	}

	/**
	 * Méthode pour le hook caroufredselJs permettant d'afficher le code javascript en bas de page
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function caroufredselJs($params,$width = 620) {

		if (isset($params['mode'])) {// == 'static'
			$id = $params['id'];
			$idcf = 'static-'.$params['id'];
		}else{
			$id = $params['cfartId'];
			$idcf = $params['cfauthor'].'-'.$id;
		}

		if ($direction = !in_array($params['direction'],array('up','down'))) {
//echo '//left & right';
			$ens = array('width','larg','height','haut');
		} else {
//echo '//up & down';
			$ens = array('height','haut','width','larg');
		}

		if (!in_array($params['width'],array('auto','variable','null'))) {
			$params['width'] = intval($params['width']);
		} elseif(NAN === $params['width']) {//NAN === $params['width'] # https://php.net/manual/en/function.is-nan.php#107929
			$params['width'] = "'".$params['width']."'";
		}
		if (empty($params['width']) || $params['width'] == 'null') {
			$params['width'] = $direction?$width:'"variable"';
		}

		if (!in_array($params['height'],array('auto','variable','null'))) {
			$params['height'] = intval($params['height']);
		} elseif(NAN === $params['height']) {//NAN === $params['width'] # https://php.net/manual/en/function.is-nan.php#107929
			$params['height'] = "'".$params['height']."'";//'"auto"''"variable"'
		}
  if (empty($params['height']) || $params['height'] == 'null') {
			$params['height'] = $direction?'"variable"':222;
		}
		//$haut = $params['height'];


		if ($params['cfprevnext'] == 'on') {
			$prevnext = ',
				prev:{
					button:"#diaporama-'.$idcf.'-prev",
					key:"left"
				},
				next:{ 
					button:"#diaporama-'.$idcf.'-next",
					key:"right"
				}'.PHP_EOL;
		} else {
			$prevnext = '';
		}
/*
			height : cf_'.$id.'_hauteur,//'.$params['height'].'
*/
		$js = '
  
		var cf_'.$id.'_diapo = $("#diaporama-'.$idcf.'");
		var cf_'.$id.'_largeur = cf_'.$id.'_diapo.data("cflarg");
		var cf_'.$id.'_hauteur = cf_'.$id.'_diapo.data("cfhaut");
		var cf_'.$id.'_nb_img = Math.floor(1+'.(int)$params[$ens[0]].' / (cf_'.$id.'_'.$ens[1].'eur + 30));

//console.log("test carouFredSelcf 00", cf_'.$id.'_diapo, cf_'.$id.'_hauteur, cf_'.$id.'_largeur, cf_'.$id.'_nb_img);
//console.log("test carouFredSelcf 01", '.$params['width'].', (cf_'.$id.'_largeur + 30), '.$params['width'].' / (cf_'.$id.'_largeur + 30), cf_'.$id.'_largeur, cf_'.$id.'_nb_img);
console.log("test '.$id.' carouFredSelcf 1 height",cf_'.$id.'_hauteur, "width",cf_'.$id.'_largeur, "nb_img",cf_'.$id.'_nb_img);

		cf_'.$id.'_diapo.carouFredSel({
//			responsive: false,//defalt
//			synchronise: false,//defalt
//			circular: true,//defalt

			'.$ens[0].' : (cf_'.$id.'_'.$ens[1].'eur*cf_'.$id.'_nb_img) + (30*cf_'.$id.'_nb_img),
			'.$ens[2].' : cf_'.$id.'_'.$ens[3].'eur,
/*
			width : (cf_'.$id.'_largeur*cf_'.$id.'_nb_img) + (35*cf_'.$id.'_nb_img),
			height : cf_'.$id.'_hauteur,
*/
			items: {
//				start: 0,
				width: cf_'.$id.'_largeur + 30, //"variable", //
				height: cf_'.$id.'_hauteur + 30 //origin //"variable"
			},
			direction : "'.$params['direction'].'",
			infinite: '.$params['infinite'].',
			auto    : '.$params['auto'].',
			scroll	: {
				items	: 1,
				pauseOnHover : true
			}'.$prevnext.',
			pagination : "#diaporama-'.$idcf.'-pages"
		});
//console.log("test '.$id.' carouFredSelcf END params[height]",'.$params['height'].', "params[width]",'.$params['width'].');
'.PHP_EOL;
		/*if($js) */$this->launchJs .= PHP_EOL.'	<script type="text/javascript">'.$js.';</script>'.PHP_EOL;
	}

	/**
	 * Méthode pour le hook caroufredselMobileJs permettant d'afficher le code javascript en bas de page pour les themes mobile
	 */
	public function caroufredselMobileJs($params) {
		caroufredselJs($params,100);
	}

/**************************
*
*	HOOKS SIMPLIFIES
*
**************************/

	/**
	 * Méthode permettant d'afficher le javascript en fonction de la page où on se trouve (home ou article)
	 * Permet de n'utiliser qu'un seul hook dans le footer
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function caroufredselFooter(){
echo '<?php '; ?>
				if ($plxShow->mode() == 'article'){
					if ($plxShow->plxMotor->plxRecord_arts->f('cfsel') == 'on'){
						$hfred = array();
						$cfred = explode(' ','cfartId width height direction infinite auto cfauthor cfprevnext');
						foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->plxRecord_arts->f($sfparm);
						eval($plxShow->callHook('caroufredselJs',$hfred));
					}
				}elseif ($plxShow->mode() == 'static'){
					if ($plxShow->plxMotor->aStats[$plxShow->plxMotor->cible ]['cfsel'] == 'on'){
						$hfred = array('mode' => 'static', 'id' => $plxShow->plxMotor->cible);
						$cfred = explode(' ','width height direction infinite auto cfauthor cfprevnext');
						foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->aStats[$plxShow->plxMotor->cible][$sfparm];
						eval($plxShow->callHook('caroufredselJs', $hfred));
					}
				} 
?><?php
	}

	/**
	 * Méthode permettant d'afficher le javascript en fonction de la page où on se trouve (home ou article)
	 * Permet de n'utiliser qu'un seul hook dans le footer des thèmes mobile
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function caroufredselFooterMobile(){
echo '<?php '; ?>
				if ($plxShow->mode() == 'article'){
					if ($plxShow->plxMotor->plxRecord_arts->f('cfsel') == 'on'){
						$hfred = array();
						$cfred = explode(' ','cfartId width height direction infinite auto cfauthor cfprevnext');
						foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->plxRecord_arts->f($sfparm);
						eval($plxShow->callHook('caroufredselMobileJs',$hfred));
					}
				}elseif ($plxShow->mode() == 'static'){
					if ($plxShow->plxMotor->aStats[$plxShow->plxMotor->cible ]['cfsel'] == 'on'){
						$hfred = array('mode' => 'static', 'id' => $plxShow->plxMotor->cible);
						$cfred = explode(' ','width height direction infinite auto cfauthor cfprevnext');
						foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->aStats[$plxShow->plxMotor->cible][$sfparm];
						eval($plxShow->callHook('caroufredselMobileJs', $hfred));
					}
				} 
?><?php
	}

	/**
	 * Méthode permettant d'utiliser un hook simplifié dans le corps de l'article
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function caroufredselArticle() {
echo '<?php '; ?>
		if ($plxShow->plxMotor->plxRecord_arts->f('cfsel') == 'on'){
			$hfred = array('userfolder'	=> $plxShow->plxMotor->aConf['userfolders']);
			$cfred = explode(' ','cfartId width height direction infinite auto cfauthor cfprevnext');//cfsel height direction infinite auto
			foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->plxRecord_arts->f($sfparm);
			eval($plxShow->callHook('caroufredselContent',$hfred));
			}
?><?php
	}

	/**
	 * Méthode permettant d'utiliser un hook simplifié dans le corps des pages statiques
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function caroufredselStatic() {
echo '<?php '; ?>
		if (plxUtils::strCheck($plxShow->plxMotor->aStats[$plxShow->plxMotor->cible ]['cfsel']) == 'on'){
			$plxShow->plxMotor->plxPlugins->aPlugins['<?php echo __CLASS__ ?>']->media_folder = $plxShow->plxMotor->aConf['caroufredselmedias'];// data/medias/ data/images/ (OLD)
			$hfred = array('userfolder' => $plxShow->plxMotor->aConf['userfolders'], 'id' => $plxShow->plxMotor->cible);
//			$cfred = explode(' ','cfauthor cfprevnext');//width height direction infinite auto 
			$cfred = explode(' ','width height direction infinite auto cfauthor cfprevnext');//
			foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->aStats[$plxShow->plxMotor->cible][$sfparm];
			eval($plxShow->callHook('caroufredselStaticContent', $hfred));
		}
?><?php
	}

	/**
	 * Méthode permettant d'utiliser un hook simplifié dans le corps de la page d'accueil
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function caroufredselHome() {
echo '<?php '; ?>
		if ($plxShow->plxMotor->plxRecord_arts->f('cfsel') == 'on'){
			$hfred = array('userfolder'	=> $plxShow->plxMotor->aConf['userfolders']);
//			$cfred = explode(' ','cfartId width cfauthor cfprevnext');//cfsel height direction infinite auto
			$cfred = explode(' ','cfartId width height direction infinite auto cfauthor cfprevnext');//cfsel height direction infinite auto
			foreach($cfred AS $sfparm) $hfred[$sfparm] = $plxShow->plxMotor->plxRecord_arts->f($sfparm);
			eval($plxShow->callHook('caroufredselContent',$hfred));
			eval($plxShow->callHook('caroufredselJs',$hfred));
		}
?><?php
	}
}
